//	Xe[^Xo[̕\
//	Visual C++ 2008/2013 Express 32/64bit UNICODE/}`oCg

#include <windows.h>
#include <commctrl.h> 
#include <stdio.h>
#include <tchar.h>

//	CreateStatusWindowgpꍇ͈ȉ̒`LɂBgpȂꍇ̓RgAEgB
#define ENABLE_FUNC 1

#ifdef ENABLE_FUNC
	#pragma comment(lib,"comctl32.lib")
#else
	HWND CreateStatus(HWND hWnd);
#endif

TCHAR szClassName[] = _TEXT("StatusBar1");	//EBhENX

#define ID_STATUS	100		// Xe[^Xo[ID

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

void GetWinRect(HWND hWnd, int *x, int *y);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
	TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;

	if (!hPreInst) {
		myProg.style = CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc = WndProc;
		myProg.cbClsExtra = 0;
		myProg.cbWndExtra = 0;
		myProg.hInstance = hInstance;
		myProg.hIcon = NULL;
		myProg.hCursor = LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName = NULL;
		myProg.lpszClassName = szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(szClassName,
		TEXT("StatusBar1"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)){
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;

	HDC hdc;
	TCHAR buf[64];
	PAINTSTRUCT ps;
	static HWND hStatus;
	static int wx, wy;
	int sx, sy;
	int sb_size[] = { 100, 200, -1 };
	switch (msg) {
	case WM_CREATE:
#ifdef ENABLE_FUNC
		hStatus = CreateStatusWindow(WS_CHILD | SBARS_SIZEGRIP | CCS_BOTTOM | WS_VISIBLE, _TEXT(""), hWnd, ID_STATUS);
#else
		hStatus = CreateStatus(hWnd);
#endif
		SendMessage(hStatus, SB_SETPARTS, (WPARAM)3, (LPARAM)(LPINT)sb_size);
		GetWinRect(hWnd, &wx, &wy);
		ShowWindow(hStatus, SW_SHOW);
		break;
	case WM_SIZE:
		wx = LOWORD(lParam);
		wy = HIWORD(lParam);
		GetWinRect(hStatus, &sx, &sy);
		wy -= sy;
		SendMessage(hStatus, WM_SIZE, wParam, lParam);
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%.4d"), wx);
		SendMessage(hStatus, SB_SETTEXT, (WPARAM)0 | 0, (LPARAM)(LPSTR)buf);
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%.4d"), wy);
		SendMessage(hStatus, SB_SETTEXT, (WPARAM)1 | 0, (LPARAM)(LPSTR)buf);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_CLOSE:
		DestroyWindow(hStatus);
		DestroyWindow(hWnd);
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		hPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		hOldPen = (HPEN)SelectObject(hdc, hPen);
		hBrush = (HBRUSH)CreateSolidBrush(RGB(255, 0, 0)); 
		hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);

		Ellipse(hdc, wx/4, wy/4, wx*3/4, wy*3/4);

		SelectObject(hdc, hOldPen);
		SelectObject(hdc, hOldBrush);
		DeleteObject(hPen);
		DeleteObject(hBrush);

		EndPaint(hWnd, &ps);
		break;
	default:
		return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0);
}

void GetWinRect(HWND hWnd, int *x, int *y){
	RECT rc;
	GetClientRect(hWnd, &rc);
	*x = rc.right - rc.left;
	*y = rc.bottom - rc.top;
	return;
}

#ifndef ENABLE_FUNC

HWND CreateStatus(HWND hWnd){
	HINSTANCE hInst;
	hInst = (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE);
	HWND hStatus = CreateWindowEx(
		0,
		STATUSCLASSNAME,
		NULL,
		WS_CHILD | SBARS_SIZEGRIP | CCS_BOTTOM | WS_VISIBLE,
		0,
		0,
		0,
		0,
		hWnd,
		(HMENU)ID_STATUS,
		hInst,
		NULL);
	return hStatus;
}

#endif
